VERSION 5.00
Begin VB.Form frmAXEDEMO 
   Caption         =   "PICAXE Compiler Demo"
   ClientHeight    =   4665
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9180
   LinkTopic       =   "Form1"
   ScaleHeight     =   4665
   ScaleWidth      =   9180
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraSettings 
      Caption         =   "Settings:"
      Height          =   4215
      Left            =   6840
      TabIndex        =   1
      Top             =   240
      Width           =   2175
      Begin VB.CheckBox chkShow 
         Caption         =   "Show Compiler"
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   2400
         Value           =   1  'Checked
         Width           =   1935
      End
      Begin VB.CheckBox chkSyntax 
         Caption         =   "Syntax Check Only"
         Height          =   375
         Left            =   120
         TabIndex        =   5
         Top             =   2760
         Width           =   1935
      End
      Begin VB.CommandButton cmdRun 
         Caption         =   "Run"
         Height          =   495
         Left            =   240
         TabIndex        =   4
         Top             =   3480
         Width           =   1575
      End
      Begin VB.ComboBox cboPort 
         Height          =   315
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   3
         Top             =   1440
         Width           =   1935
      End
      Begin VB.ComboBox cboPICAXE 
         Height          =   315
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   2
         Top             =   600
         Width           =   1935
      End
   End
   Begin VB.TextBox txtText 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3975
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   360
      Width           =   6375
   End
End
Attribute VB_Name = "frmAXEDEMO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdRun_Click()

Dim cmd_line As String
Dim file_name As String
Dim log_file_name As String
Dim temp_text As String
Dim msg_text As String

Dim f, retval, length


' get the compiler name
cmd_line = App.Path & "\" & LCase(cboPICAXE.List(cboPICAXE.ListIndex)) & ".exe"


' does it exist - if not will error
On Error GoTo compiler_not_found
retval = FileDateTime(cmd_line)

' generate the filename test.bas in the Windows temporary folder
file_name = GetTemp() & "test.bas"
log_file_name = GetTemp() & "test.err"

' delete files if already there (trap error)
On Error Resume Next

Kill (file_name)
Kill (log_file_name)

'redirect error trap now kills are over
On Error GoTo end_it

'save the text
If txtText.Text = "" Then
    MsgBox "No text to compile!", vbExclamation, "Error:"
    Exit Sub
Else
    f = FreeFile
    Open file_name For Output As #f
        Print #f, txtText.Text
    Close #f
End If


' Now finish the command line structure

' add -s switch if required to command line
If chkSyntax.Value = 1 Then
    cmd_line = cmd_line & " -s"
End If

' always add pass message -p and com port -c
cmd_line = cmd_line & " -p -c" & UCase(cboPort.List(cboPort.ListIndex))

' add the filename within " (chr(34)) marks
' this prevents long filenames (with spaces) issues
cmd_line = cmd_line & " " & Chr(34) & file_name & Chr(34)

' report the cmd_line to check it is ok
' MsgBox "Testing, cmd_line is:" & vbCrLf & cmd_line

' now do it
' lock screen and mousepointer to give some visual user feedback!
Screen.MousePointer = 11
cmdRun.Enabled = False
cmdRun.Caption = "Please wait..."
txtText.Enabled = False

DoEvents
retval = ExecCmd(cmd_line, chkShow.Value)

cmdRun.Enabled = True
cmdRun.Caption = "Run"
txtText.Enabled = True
Screen.MousePointer = 0
 
 
' now retrieve error/pass message from log file
    f = FreeFile
    Open log_file_name For Input As #f
    
    length = LOF(f)
    Do While Not EOF(f)
        Line Input #f, temp_text
        msg_text = msg_text & temp_text & vbCrLf
    Loop
        
    Close f

    'display report
    MsgBox msg_text, vbOKOnly & vbInformation, "Result"
    
    Exit Sub

end_it:
    MsgBox "Oops - error:" & vbCrLf & Err.Description, vbExclamation, "Error:"
    Exit Sub
    
compiler_not_found:
    MsgBox "Compiler file not found at path:" + vbCrLf + cmd_line + vbCrLf + vbCrLf + "Please download (free!) from www.picaxe.co.uk", vbExclamation, "Error:"
    Exit Sub
    
    
End Sub

Private Sub Form_Load()

Dim i As Integer
Dim cLeft As Integer
Dim cTop As Integer

'centre any form on the screen
cLeft = (Screen.Width - Me.Width) / 2
cTop = (Screen.Height - Me.Height) / 2
Me.Move cLeft, cTop
    


' add com ports
For i = 1 To 255
cboPort.AddItem ("COM" & Right(Str(i), (Len(Str(i)) - 1)))
Next i
cboPort.ListIndex = 0

' add picaxe options
cboPICAXE.AddItem ("PICAXE08")
cboPICAXE.AddItem ("PICAXE08M")
cboPICAXE.AddItem ("PICAXE14M")
cboPICAXE.AddItem ("PICAXE20M")
cboPICAXE.AddItem ("PICAXE18")
cboPICAXE.AddItem ("PICAXE18A")
cboPICAXE.AddItem ("PICAXE18X")
cboPICAXE.AddItem ("PICAXE28A")
cboPICAXE.AddItem ("PICAXE28X")
cboPICAXE.AddItem ("PICAXE28X1")
cboPICAXE.AddItem ("PICAXE28X2")
cboPICAXE.AddItem ("PICAXE40X")
cboPICAXE.AddItem ("PICAXE40X1")
cboPICAXE.AddItem ("PICAXE40X2")
cboPICAXE.ListIndex = 1

'preload a test program
txtText.Text = "main:" & vbCrLf
txtText.Text = txtText.Text & vbTab & "high 0" & vbCrLf
txtText.Text = txtText.Text & vbTab & "pause 1000" & vbCrLf
txtText.Text = txtText.Text & vbTab & "low 0" & vbCrLf
txtText.Text = txtText.Text & vbTab & "pause 1000" & vbCrLf
txtText.Text = txtText.Text & vbTab & "goto main" & vbCrLf



End Sub
